'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduxLoop = require('redux-loop');

var _actions = require('./actions');

exports.default = function (tasks) {
  return function () {
    var state = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];
    var action = arguments[1];

    if (action.type === _actions.TRANSITION) {
      return (0, _reduxLoop.loop)(state, _reduxLoop.Cmd.call(tasks.transition, action.method, action.args));
    }

    if (action.type === _actions.UPDATE_LOCATION) {
      return (0, _reduxLoop.loop)(_extends({}, state, {
        location: action.location
      }), _reduxLoop.Cmd.none);
    }

    return (0, _reduxLoop.loop)(state, _reduxLoop.Cmd.none);
  };
};
